﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using TrolleybusProject.Drawnings;

namespace TrolleybusProject.CollectionGenericObjects;

public class BusStation : AbstractCompany
{
    public BusStation(int picWidth, int picHeight, ICollectionGenericObjects<DrawningBus> collection) : base(picWidth, picHeight, collection)
    {
    }

    protected override void DrawBackgound(Graphics g)
    {
        Pen pen = new(Color.Black, 3);
        for (int i = 0; i < _pictureWidth / _placeSizeWidth; i++)
        {
            for (int j = 0; j < _pictureHeight / _placeSizeHeight + 1; ++j)
            {
                g.DrawLine(pen, i * _placeSizeWidth + 4, j * _placeSizeHeight, i * _placeSizeWidth +4 + _placeSizeWidth - 95, j * _placeSizeHeight);
                g.DrawLine(pen, i * _placeSizeWidth +4, j * _placeSizeHeight, i * _placeSizeWidth +4, j * _placeSizeHeight + _placeSizeHeight);
            }
        }
    }

    protected override void SetObjectsPosition()
    {
        int Width = _pictureWidth / _placeSizeWidth - 1;
        int Height = 0;

        for (int i = 0; i < (_collection?.Count ?? 0); i++)
        {
            if (_collection.Get(i) != null)
            {
                _collection.Get(i).SetPictureSize(_pictureWidth, _pictureHeight);
                _collection.Get(i).SetPosition(_placeSizeWidth * Width + 20, Height * _placeSizeHeight + 10);
            }

            if (Width > 0)
                Width--;
            else
            {
                Width = _pictureWidth / _placeSizeWidth - 1;
                Height++;
            }
            if (Height > _pictureHeight / _placeSizeHeight)
            {
                return;
            }
        }
    }
}
 

