﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace TrolleybusProject.CollectionGenericObjects;

internal class MassiveGenericObjects<T> : ICollectionGenericObjects<T>
    where T : class
{
    //// <summary>
    /// Массив объектов которые храним
    /// </summary>
    private T?[] _collection;

    public int Count => _collection.Length;

    public int SetMaxCount { set { if (value > 0) { _collection = new T?[value]; } } }

    /// <summary>
    /// Конструктор
    /// </summary>
    public MassiveGenericObjects()
    {
        _collection = Array.Empty<T?>();
    }

    public T? Get(int position)
    {
        if (position >= _collection.Length || position < 0)
        {
            return null;
        }
        return _collection[position];
    }

    public int Insert(T obj)
    {
        int index = 0;
        while (index < _collection.Length)
        {
            if (_collection[index] == null)
            {
                _collection[index] = obj;
                return index;
            }
            index++;
        }
        return -1;
    }

    public int Insert(T obj, int position)
    {

        if (position >= _collection.Length || position < 0)
            return -1;


        if (_collection[position] != null)
        {
            int nullIndex = -1;
            for (int i = position + 1; i < Count; i++)
            {
                if (_collection[i] == null)
                {
                    nullIndex = i;
                    break;
                }
            }
                 if (nullIndex < 0)
            {
                return -1;
            }
            int j = nullIndex - 1;
            while (j >= position)
            {
                _collection[j + 1] = _collection[j];
                j--;
            }
        }
        _collection[position] = obj;
        return position;
    }

    public T? Remove(int position)
    {
        if (position >= _collection.Length || position < 0)
        {
            return null;
        }
        T? temp = _collection[position];
        _collection[position] = null;
        return temp;
    }

}
