﻿using TrolleybusProject.Entities;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;


using static System.Windows.Forms.VisualStyles.VisualStyleElement;
namespace TrolleybusProject.Drawnings;

public class DrawningTrolleybus:DrawningBus
{
    /// <summary>
    /// Клнструктор
    /// </summary>
    /// <param name="speed">Скорость</param>
    /// <param name="weight">Вес</param>
    /// <param name="bodyColor">Основной цвет</param>
    /// <param name="additionalColor">Дополнительный цвет</param>
    /// <param name="roga">Признак наличия рогов</param>
    /// <param name="doors">Признак наличия дверей</param>
    /// <param name="otsek">Признак наличия отсека</param>
    public DrawningTrolleybus(int speed, double weight, Color bodyColor, Color
    additionalColor, bool doors, bool roga, bool otsek):base(150,86)
    {
        EntityBus = new EntityTrolleybus(speed, weight, bodyColor, additionalColor,
        doors, roga, otsek);

    }

    public override void DrawTransport(Graphics g)
    {
        if (EntityBus == null || EntityBus is not  EntityTrolleybus trolleybus|| !_startPosX.HasValue ||
        !_startPosY.HasValue)
        {
            return;
        }

        Pen pen = new(Color.Black);
        Brush additionalBrush = new SolidBrush(trolleybus.AdditionalColor);
        Pen addpen = new(trolleybus.AdditionalColor);
        _startPosX += 5;
        _startPosY += 22;

        base.DrawTransport(g);
        _startPosX -= 5;
        _startPosY -= 22;

        if (trolleybus.Otsek)
        {
            g.DrawRectangle(pen, _startPosX.Value + 5, _startPosY.Value +
             48, 5, 20);
            g.FillRectangle(additionalBrush, _startPosX.Value + 5, _startPosY.Value +
            48, 5, 20);

            g.DrawRectangle(pen, _startPosX.Value + 5, _startPosY.Value +
            48, 5, 20);
            }

        //двойная дверь

        if (trolleybus.Doors)
        {
            g.DrawLine(addpen, _startPosX.Value + 66, _startPosY.Value + 40,
           _startPosX.Value + 66, _startPosY.Value + 70);
        }
        //рога

        if (trolleybus.Roga)
        {
            g.DrawLine(addpen, _startPosX.Value + 42, _startPosY.Value + 7,
           _startPosX.Value + 124, _startPosY.Value + 29);
            g.DrawLine(addpen, _startPosX.Value + 62, _startPosY.Value + 2,
          _startPosX.Value + 124, _startPosY.Value + 29);

        }

    }

}
    
    





